Awkward Array: ForthMachineOf< T, I > Class Template Reference

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ForthMachineOf< T, I > Class Template Reference

`#include <ForthMachine.h>`

## Public Member Functions
| ForthMachineOf (const std::string &source, int64_t stack_max_depth=1024, int64_t recursion_max_depth=1024, int64_t string_buffer_size=1024, int64_t output_initial_size=1024, double output_resize_factor=1.5)
| ~ForthMachineOf ()
const std::string | source () const noexcept
| HERE. More...
const ContentPtr | bytecodes () const
| HERE. More...
const std::string | decompiled () const
| HERE. More...
const std::string | decompiled_segment (int64_t segment_position, const std::string &indent="", bool endline=true) const
| HERE. More...
const std::string | decompiled_at (int64_t bytecode_position, const std::string &indent="") const
| HERE. More...
const std::vector< std::string > | dictionary () const
| HERE. More...
int64_t | stack_max_depth () const noexcept
| HERE. More...
int64_t | recursion_max_depth () const noexcept
| HERE. More...
int64_t | string_buffer_size () const noexcept
| HERE. More...
int64_t | output_initial_size () const noexcept
| HERE. More...
double | output_resize_factor () const noexcept
| HERE. More...
const std::vector< T > | stack () const
| HERE. More...
T | stack_at (int64_t from_top) const noexcept
| HERE. More...
int64_t | stack_depth () const noexcept
| HERE. More...
bool | stack_can_push () const noexcept
| HERE. More...
bool | stack_can_pop () const noexcept
| HERE. More...
void | stack_push (T value) noexcept
| HERE. More...
T | stack_pop () noexcept
| HERE. More...
void | stack_clear () noexcept
| HERE. More...
const std::map< std::string, T > | variables () const
| HERE. More...
const std::vector< std::string > | variable_index () const
| HERE. More...
T | variable_at (const std::string &name) const
| HERE. More...
T | variable_at (int64_t index) const noexcept
| HERE. More...
bool | input_must_be_writable (const std::string &name) const
| HERE. More...
int64_t | input_position_at (const std::string &name) const
| HERE. More...
int64_t | input_position_at (int64_t index) const noexcept
| HERE. More...
const std::map< std::string, std::shared_ptr< ForthOutputBuffer > > | outputs () const
| HERE. More...
const std::vector< std::string > | output_index () const noexcept
| HERE. More...
const std::shared_ptr< ForthOutputBuffer > | output_at (const std::string &name) const
| HERE. More...
const std::shared_ptr< ForthOutputBuffer > | output_at (int64_t index) const noexcept
| HERE. More...
const ContentPtr | output_NumpyArray_at (const std::string &name) const
| HERE. More...
const ContentPtr | output_NumpyArray_at (int64_t index) const
| HERE. More...
const Index8 | output_Index8_at (const std::string &name) const
| HERE. More...
const Index8 | output_Index8_at (int64_t index) const
| HERE. More...
const IndexU8 | output_IndexU8_at (const std::string &name) const
| HERE. More...
const IndexU8 | output_IndexU8_at (int64_t index) const
| HERE. More...
const Index32 | output_Index32_at (const std::string &name) const
| HERE. More...
const Index32 | output_Index32_at (int64_t index) const
| HERE. More...
const IndexU32 | output_IndexU32_at (const std::string &name) const
| HERE. More...
const IndexU32 | output_IndexU32_at (int64_t index) const
| HERE. More...
const Index64 | output_Index64_at (const std::string &name) const
| HERE. More...
const Index64 | output_Index64_at (int64_t index) const
| HERE. More...
const std::string | string_at (int64_t index) const noexcept
| Returns a string at 'index'. The strings are defined with an 's"' core word. More...
void | reset ()
| HERE. More...
void | begin (const std::map< std::string, std::shared_ptr< ForthInputBuffer > > &inputs)
| HERE. More...
void | begin ()
| HERE. More...
util::ForthError | begin_again (const std::map< std::string, std::shared_ptr< ForthInputBuffer > > &inputs, bool reset_instruction)
| HERE. More...
util::ForthError | step ()
| HERE. More...
util::ForthError | run (const std::map< std::string, std::shared_ptr< ForthInputBuffer > > &inputs)
| HERE. More...
util::ForthError | run ()
| HERE. More...
util::ForthError | resume ()
| HERE. More...
util::ForthError | call (const std::string &name)
| HERE. More...
util::ForthError | call (int64_t index)
| HERE. More...
void | maybe_throw (util::ForthError err, const std::set< util::ForthError > &ignore) const
| HERE. More...
int64_t | current_bytecode_position () const noexcept
| HERE. More...
int64_t | current_recursion_depth () const noexcept
| HERE. More...
const std::string | current_instruction () const
| HERE. More...
void | count_reset () noexcept
| HERE. More...
int64_t | count_instructions () const noexcept
| HERE. More...
int64_t | count_reads () const noexcept
| HERE. More...
int64_t | count_writes () const noexcept
| HERE. More...
int64_t | count_nanoseconds () const noexcept
| HERE. More...
bool | is_integer (const std::string &word, int64_t &value) const
| HERE. More...
bool | is_variable (const std::string &word) const
| HERE. More...
bool | is_input (const std::string &word) const
| HERE. More...
bool | is_output (const std::string &word) const
| HERE. More...
bool | is_nbit (const std::string &word, I &value) const
| HERE. More...
bool | is_reserved (const std::string &word) const
| HERE. More...
bool | is_defined (const std::string &word) const
| HERE. More...
bool | is_ready () const noexcept
| HERE. More...
bool | is_done () const noexcept
| HERE. More...
bool | is_segment_done () const noexcept
| HERE. More...

## Constructor & Destructor Documentation

## ◆ ForthMachineOf()

ForthMachineOf | ( | const std::string & | source,
|  | int64_t | stack_max_depth = `1024`,
|  | int64_t | recursion_max_depth = `1024`,
|  | int64_t | string_buffer_size = `1024`,
|  | int64_t | output_initial_size = `1024`,
|  | double | output_resize_factor = `1.5`
| ) |  |

## ◆ ~ForthMachineOf()

~ForthMachineOf | ( |  | ) |

## Member Function Documentation

## ◆ begin() [1/2]

void begin | ( |  | ) |

HERE.

## ◆ begin() [2/2]

void begin | ( | const std::map< std::string, std::shared_ptr< ForthInputBuffer > > & | inputs | ) |

HERE.

## ◆ begin_again()

util::ForthError begin_again | ( | const std::map< std::string, std::shared_ptr< ForthInputBuffer > > & | inputs,
|  | bool | reset_instruction
| ) |  |

HERE.

## ◆ bytecodes()

const ContentPtr bytecodes | ( |  | ) | const

HERE.

## ◆ call() [1/2]

util::ForthError call | ( | const std::string & | name | ) |

HERE.

## ◆ call() [2/2]

util::ForthError call | ( | int64_t | index | ) |

HERE.

## ◆ count_instructions()

int64_t count_instructions | ( |  | ) | const
| noexcept

HERE.

## ◆ count_nanoseconds()

int64_t count_nanoseconds | ( |  | ) | const
| noexcept

HERE.

## ◆ count_reads()

int64_t count_reads | ( |  | ) | const
| noexcept

HERE.

## ◆ count_reset()

void count_reset | ( |  | ) |
| noexcept

HERE.

## ◆ count_writes()

int64_t count_writes | ( |  | ) | const
| noexcept

HERE.

## ◆ current_bytecode_position()

int64_t current_bytecode_position | ( |  | ) | const
| noexcept

HERE.

## ◆ current_instruction()

const std::string current_instruction | ( |  | ) | const

HERE.

## ◆ current_recursion_depth()

int64_t current_recursion_depth | ( |  | ) | const
| noexcept

HERE.

## ◆ decompiled()

const std::string decompiled | ( |  | ) | const

HERE.

## ◆ decompiled_at()

const std::string decompiled_at | ( | int64_t | bytecode_position,
|  | const std::string & | indent = `""`
| ) |  | const

HERE.

## ◆ decompiled_segment()

const std::string decompiled_segment | ( | int64_t | segment_position,
|  | const std::string & | indent = `""`,
|  | bool | endline = `true`
| ) |  | const

HERE.

## ◆ dictionary()

const std::vector< std::string > dictionary | ( |  | ) | const

HERE.

## ◆ input_must_be_writable()

bool input_must_be_writable | ( | const std::string & | name | ) | const

HERE.

## ◆ input_position_at() [1/2]

int64_t input_position_at | ( | const std::string & | name | ) | const

HERE.

## ◆ input_position_at() [2/2]

int64_t input_position_at | ( | int64_t | index | ) | const
| noexcept

HERE.

## ◆ is_defined()

bool is_defined | ( | const std::string & | word | ) | const

HERE.

## ◆ is_done()

bool is_done | ( |  | ) | const
| inlinenoexcept

HERE.

## ◆ is_input()

bool is_input | ( | const std::string & | word | ) | const

HERE.

## ◆ is_integer()

bool is_integer | ( | const std::string & | word,
|  | int64_t & | value
| ) |  | const

HERE.

## ◆ is_nbit()

bool is_nbit | ( | const std::string & | word,
|  | I & | value
| ) |  | const

HERE.

## ◆ is_output()

bool is_output | ( | const std::string & | word | ) | const

HERE.

## ◆ is_ready()

bool is_ready | ( |  | ) | const
| inlinenoexcept

HERE.

## ◆ is_reserved()

bool is_reserved | ( | const std::string & | word | ) | const

HERE.

## ◆ is_segment_done()

bool is_segment_done | ( |  | ) | const
| inlinenoexcept

HERE.

## ◆ is_variable()

bool is_variable | ( | const std::string & | word | ) | const

HERE.

## ◆ maybe_throw()

void maybe_throw | ( | util::ForthError | err,
|  | const std::set< util::ForthError > & | ignore
| ) |  | const

HERE.

## ◆ output_at() [1/2]

const std::shared_ptr< ForthOutputBuffer > output_at | ( | const std::string & | name | ) | const

HERE.

## ◆ output_at() [2/2]

const std::shared_ptr< ForthOutputBuffer > output_at | ( | int64_t | index | ) | const
| noexcept

HERE.

## ◆ output_index()

const std::vector< std::string > output_index | ( |  | ) | const
| noexcept

HERE.

## ◆ output_Index32_at() [1/2]

const Index32 output_Index32_at | ( | const std::string & | name | ) | const

HERE.

## ◆ output_Index32_at() [2/2]

const Index32 output_Index32_at | ( | int64_t | index | ) | const

HERE.

## ◆ output_Index64_at() [1/2]

const Index64 output_Index64_at | ( | const std::string & | name | ) | const

HERE.

## ◆ output_Index64_at() [2/2]

const Index64 output_Index64_at | ( | int64_t | index | ) | const

HERE.

## ◆ output_Index8_at() [1/2]

const Index8 output_Index8_at | ( | const std::string & | name | ) | const

HERE.

## ◆ output_Index8_at() [2/2]

const Index8 output_Index8_at | ( | int64_t | index | ) | const

HERE.

## ◆ output_IndexU32_at() [1/2]

const IndexU32 output_IndexU32_at | ( | const std::string & | name | ) | const

HERE.

## ◆ output_IndexU32_at() [2/2]

const IndexU32 output_IndexU32_at | ( | int64_t | index | ) | const

HERE.

## ◆ output_IndexU8_at() [1/2]

const IndexU8 output_IndexU8_at | ( | const std::string & | name | ) | const

HERE.

## ◆ output_IndexU8_at() [2/2]

const IndexU8 output_IndexU8_at | ( | int64_t | index | ) | const

HERE.

## ◆ output_initial_size()

int64_t output_initial_size | ( |  | ) | const
| noexcept

HERE.

## ◆ output_NumpyArray_at() [1/2]

const ContentPtr output_NumpyArray_at | ( | const std::string & | name | ) | const

HERE.

## ◆ output_NumpyArray_at() [2/2]

const ContentPtr output_NumpyArray_at | ( | int64_t | index | ) | const

HERE.

## ◆ output_resize_factor()

double output_resize_factor | ( |  | ) | const
| noexcept

HERE.

## ◆ outputs()

const std::map< std::string, std::shared_ptr< ForthOutputBuffer > > outputs | ( |  | ) | const

HERE.

## ◆ recursion_max_depth()

int64_t recursion_max_depth | ( |  | ) | const
| noexcept

HERE.

## ◆ reset()

void reset | ( |  | ) |

HERE.

## ◆ resume()

util::ForthError resume | ( |  | ) |

HERE.

## ◆ run() [1/2]

util::ForthError run | ( |  | ) |

HERE.

## ◆ run() [2/2]

util::ForthError run | ( | const std::map< std::string, std::shared_ptr< ForthInputBuffer > > & | inputs | ) |

HERE.

## ◆ source()

const std::string source | ( |  | ) | const
| noexcept

HERE.

## ◆ stack()

const std::vector< T > stack | ( |  | ) | const

HERE.

## ◆ stack_at()

T stack_at | ( | int64_t | from_top | ) | const
| noexcept

HERE.

## ◆ stack_can_pop()

bool stack_can_pop | ( |  | ) | const
| inlinenoexcept

HERE.

## ◆ stack_can_push()

bool stack_can_push | ( |  | ) | const
| inlinenoexcept

HERE.

## ◆ stack_clear()

void stack_clear | ( |  | ) |
| noexcept

HERE.

## ◆ stack_depth()

int64_t stack_depth | ( |  | ) | const
| noexcept

HERE.

## ◆ stack_max_depth()

int64_t stack_max_depth | ( |  | ) | const
| noexcept

HERE.

## ◆ stack_pop()

T stack_pop | ( |  | ) |
| inlinenoexcept

HERE.

## ◆ stack_push()

void stack_push | ( | T | value | ) |
| inlinenoexcept

HERE.

## ◆ step()

util::ForthError step | ( |  | ) |

HERE.

## ◆ string_at()

const std::string string_at | ( | int64_t | index | ) | const
| noexcept

Returns a string at 'index'. The strings are defined with an 's"' core word.

## ◆ string_buffer_size()

int64_t string_buffer_size | ( |  | ) | const
| noexcept

HERE.

## ◆ variable_at() [1/2]

T variable_at | ( | const std::string & | name | ) | const

HERE.

## ◆ variable_at() [2/2]

T variable_at | ( | int64_t | index | ) | const
| noexcept

HERE.

## ◆ variable_index()

const std::vector< std::string > variable_index | ( |  | ) | const

HERE.

## ◆ variables()

const std::map< std::string, T > variables | ( |  | ) | const

HERE.

The documentation for this class was generated from the following file:

- include/awkward/forth/ForthMachine.h